package ca.recrown.islandsurvivalcraft.interaction.commands.runnables;

import java.util.concurrent.CompletableFuture;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;
import ca.recrown.islandsurvivalcraft.interaction.commands.Commands;

public class HelpCommand implements CommandRunnable {
    private String helpMessage;
    @Override
    public String getDescription() {
        return "Displays these help messages.";
    }

    @Override
    public CompletableFuture<String> invoke(CommandSender sender, String[] args) {
        CompletableFuture<String> completableFuture = new CompletableFuture<>();
        if (args == null || args.length == 0) {
            completableFuture.complete(helpMessage);
        } else {
            Commands command = null;
            try {
                command = Commands.valueOf(args[0].toUpperCase());
            } catch (IllegalArgumentException e) {
                completableFuture.complete(ChatColor.LIGHT_PURPLE + String.format("The request %s does not exist. Please type \"/IslandSurvivalCraft help\" for more info.", args[0]));
                return completableFuture;
            }
            StringBuilder sb = new StringBuilder();
            sb.append(ChatColor.YELLOW + args[0]);
            sb.append(": " + ChatColor.GRAY);
            sb.append(command.getDescription());
            sb.append("\n" + ChatColor.WHITE);
            sb.append(command.getDetailedDescription());
            completableFuture.complete(sb.toString().trim());
        }
        return completableFuture;
    }

    @Override
    public void initialize(IslandSurvivalCraft islandSurvivalCraft) {
        StringBuilder stringBuilder = new StringBuilder();
        Commands[] commands = Commands.values();
        stringBuilder.append(ChatColor.YELLOW + "Commands:\n");
        for (int i = 0; i < commands.length; i++) {
            stringBuilder.append(ChatColor.GREEN + commands[i].toString());
            stringBuilder.append(": " + ChatColor.WHITE);
            stringBuilder.append(commands[i].getDescription());
            stringBuilder.append("\n");
        }
        helpMessage = stringBuilder.toString().trim();
    }

    @Override
    public String getDetailedDescription() {
        return " \"islandsurvivalcraft help [command]\". Where [command] is a listed command, can optionally be added to get a detailed look at the command. Help is a command that lists all the other potential commands that may be run. Can also look at the detailed commands. But you knew this since your using help with help...";
    }
    
}